﻿using System;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;

namespace CustomAggregatorSample
{
    public class GrossProfitAggregator : Aggregator<double>
    {
        private FlatDataSource _flatDataSource;
        private IAggregateable _salesMeasure;

        public GrossProfitAggregator(FlatDataSource flatDataSource)
        {
            this._flatDataSource = flatDataSource;
            this._flatDataSource.Initialized += this.DataSource_Initialized;
        }

        private void DataSource_Initialized(object sender, EventArgs e)
        {
            // get other aggregateables you are interested in
            this._salesMeasure = (IAggregateable)this._flatDataSource.Cube.Measures["SalesAmount"];
        }

        public override IAggregationResult<double, double> Evaluate(IAggregationResult<double, double> oldResult, double value)
        {
            throw new NotImplementedException();
        }

        public override IAggregationResult<double, double> Evaluate(IAggregationResult<double, double> oldResult, IAggregateable aggregateable, System.Collections.IEnumerable items)
        {
            double grossProfit = 0;
            double sales = 0;

            // iterate through all items that participate in this cell
            foreach (var item in items)
            {
                // aggregateable points to GrossProfit property because
                // in this measure dimension metadata SourcePropertyName = "GrossProfit" 
                grossProfit += (double)aggregateable.GetValue(item);
                sales += (double) this._salesMeasure.GetValue(item);
            }

            double result = grossProfit/sales;
            return new SingleResult<double>(result);
        }
    }
}